{% from "packages/components/date-input/macro.njk" import dateInput %}
{% from 'packages/components/error-message/macro.njk' import errorMessage %}

{#
  hceDateInput() wraps nhsukDateInput() providing custom error handling
  for the three fields (day / month / year)

  params:
  fieldIdPrefix: string
  fieldNamePrefix: string
  claim: object (associates user entered values with date fields)
  errors: array (provided by express-validator)
  legend: object (see govukDateInput macro params)
  hint: object (see govukDateInput macro params)
#}
{% macro hceDateInput(params) %}
{% set errorMessageDay = params.errors | getErrorForField(params.fieldNamePrefix + '-day') %}
{% set errorMessageMonth = params.errors | getErrorForField(params.fieldNamePrefix + '-month') %}
{% set errorMessageYear = params.errors | getErrorForField(params.fieldNamePrefix + '-year') %}
{% set errorMessageAll = params.errors | getErrorForField(params.fieldNamePrefix) %}
{% set errorClassDay = ' nhsuk-input--error' if errorMessageDay else '' %}
{% set errorClassMonth = ' nhsuk-input--error' if errorMessageMonth else '' %}
{% set errorClassYear = ' nhsuk-input--error' if errorMessageYear else '' %}
{% set errorClassAll = ' nhsuk-input--error' if errorMessageAll else '' %}
{% set errorMessageDayText = errorMessageDay.text + "<br>" if errorMessageDay else '' %}
{% set errorMessageMonthText = errorMessageMonth.text + "<br>" if errorMessageMonth else '' %}
{% set errorMessageYearText = errorMessageYear.text + "<br>" if errorMessageYear else '' %}
{% set errorMessageAllText = errorMessageAll.text + "<br>" if errorMessageAll else '' %}
{% set setLegend = { legend: params.legend } if params.legend else "" %}

{% if (errorMessageAllText) or (errorMessageDayText) or (errorMessageMonthText) or (errorMessageYearText) %}
  {% set errorMessageText = { html: "" + errorMessageAllText + errorMessageDayText + errorMessageMonthText + errorMessageYearText } %}
{% else %}
  {% set errorMessageText = '' %}
{% endif %}

{% set items = [
  {
    id: params.fieldIdPrefix + '-day',
    name: 'day',
    label: dayLabel,
    classes: 'nhsuk-input--width-2' + errorClassAll + errorClassDay,
    value: params.claim[params.fieldNamePrefix + '-day']
  },
  {
    id: params.fieldIdPrefix + '-month',
    name: 'month',
    label: monthLabel,
    classes: 'nhsuk-input--width-2' + errorClassAll + errorClassMonth,
    value: params.claim[params.fieldNamePrefix + '-month']
  },
  {
    id: params.fieldIdPrefix + '-year',
    name: 'year',
    label: yearLabel,
    classes: 'nhsuk-input--width-4' + errorClassAll + errorClassYear,
    value: params.claim[params.fieldNamePrefix + '-year']
  }
] %}

{{ dateInput({
  id: params.fieldNamePrefix | camelToKebabCase,
  namePrefix: params.fieldNamePrefix,
  items: items,
  errorMessage: errorMessageText,
  fieldset: setLegend,
  hint: params.hint
}) }}

{% endmacro %}
